#!/usr/bin/perl
# This script was pulled together using iseas from various places

use strict;
use warnings;

use Term::ReadKey;
use VMware::VIRuntime;

if ($#ARGV != 2) {
        print "Wrong Arguments Passed\n\n";
        print "./esxstats.pl <<sdk url>> <<username>> <<password>>\n\n";
        exit 1;
}

my $username = $ARGV[1];
my $password = $ARGV[2];
my $service_url = "https://".$ARGV[0]."/sdk";

# Login to Virtual Center service:
Vim::login(service_url => $service_url, user_name => $username, password => $password);

my $host_view = Vim::find_entity_views(
view_type => 'HostSystem',
#filter => "",
);

my ($host, $memTotal, $memUsed, $cpuMhz, $numCores, $cpuTotal, $cpuUsed);

foreach $host ( @{$host_view} )
{

$cpuMhz = $host->summary->hardware->cpuMhz;
$numCores = $host->summary->hardware->numCpuCores;
$cpuTotal = $cpuMhz * $numCores;
$cpuUsed = $host->summary->quickStats->overallCpuUsage;
$memTotal = $host->hardware->memorySize / 1048576; # in MB
$memUsed = $host->summary->quickStats->overallMemoryUsage; # in MB

printf("cputotal:%d cpuused:%d cpupercent:%0.2f memtotal:%d memused:%d mempercent:%0.2f\n", $cpuTotal, $cpuUsed, ($cpuUsed/$cpuTotal)*100, $memTotal, $memUsed, ($memUsed/$memTotal)*100);
}
